local t = {}

function SaveFramePosition(self)
	local name = self:GetName()
	if ( not name ) then
		return
	end
	local point, frame, relativepoint, x, y = self:GetPoint()
	local t = LibrarySVPC.points[name]
	if ( frame and frame:GetName() ) then 
		t.point =  point
		t.frame =  frame:GetName()
		t.relativepoint = relativepoint
		t.x =  x
		t.y =  y
	else
		t.point =  "CENTER"
		t.frame =  "UIParent"
		t.relativepoint = "BOTTOMLEFT"
		t.x, t.y = self:GetCenter()
	end
end

local a = {
	{"BOTTOMLEFT", "BOTTOMRIGHT"},
	{"BOTTOMLEFT", "TOPLEFT"},
}
local b = {
	{"TOPLEFT", "TOPRIGHT",},
	{"BOTTOMRIGHT", "TOPRIGHT"},
}

local function Eval(anchor, s, frame, i, j, ...)
	local dx = select(1+i*4+j, ...)-select(4+i*4-j, ...)
	if (  abs(dx) < 10 ) then

		local ay1, by1, ay2, by2 = select(5-i*4, ...)


		if ( ay2 < by1 and ay1 < by2 ) then
			local x, y, t
			local dy1 = ay1-ay2
			local dy2 = by1-by2
			if ( abs(dy1) < abs(dy2) ) then	
				y, t = dy1, a
			else
				y, t = dy2, b
			end
			if ( i == 1 ) then
				x, y = y, dx
			else
				x = dx
			end
			anchor:ClearAllPoints()
			anchor:SetPoint(t[1+i][j+1], frame, t[i+1][2-j], x/s, y/s) 
			return true	
		else
			j = nil
		end
	end
	if ( j == 0 ) then
		return Eval(anchor, s, frame, i, 1, ...)
	elseif ( i == 0 ) then
		return Eval(anchor, s, frame, 1, 0, ...)
	else
		return false
	end
end

local function Coords(s, frame)
	return frame:GetTop()*s, frame:GetBottom()*s, frame:GetRight()*s, frame:GetLeft()*s
end


local function LoopMe(anchor, s, frame, t1, b1, r1, l1)
	if ( frame:IsShown() and frame ~= anchor and frame:GetNumPoints() > 0 and select(2, frame:GetPoint()) ~= anchor  ) then		
		local t2, b2, r2, l2  = Coords(frame:GetEffectiveScale(), frame)
		return Eval(anchor, s, frame, 0, 0, l1, r1, l2, r2, b1, t1, b2, t2)
	end
end

local function DragStop(self)
	if ( not self.moving ) then 
		return 
	end
	local anchor = self.anchor
	anchor:StopMovingOrSizing()
	if ( not InCombatLockdown() ) then
		local s = anchor:GetEffectiveScale() 
		local top, bottom, right, left  = Coords(s, anchor)
		local k
		repeat  
			k = next(t, k)
		until not k or LoopMe(anchor, s, k, top, bottom, right, left) 
	end
	if ( t[anchor] ) then
		SaveFramePosition(anchor)
	end
end

local function DragStart(self)
	if ( not self.secure_drag or IsControlKeyDown() ) then
		self.anchor:StartMoving()
		self.moving = true
	else
		self.moving = false
	end
end

function Library_LoadPoint(k, v)
	local frame = _G[k]
	if ( frame ) then
		frame:ClearAllPoints()
		if ( _G[v.frame] ) then
			frame:SetPoint(v.point, v.frame, v.relativepoint, v.x, v.y)
		else
			frame:SetPoint("CENTER", UIParent, "CENTER")
		end
	end
end

RegisterEvent(function(_, event, arg1)
	for k, v in next, LibrarySVPC.points do	
		Library_LoadPoint(k, v)
	end
end, "PLAYER_LOGIN")--"ADDON_LOADED", "VARIABLES_LOADED")

function RegisterForAnchor(self, anchor, save)
	self.anchor = anchor
	if ( t[anchor] == nil ) then 
		anchor:SetMovable(true)
	end
	t[anchor] = save or false
	self:HookScript("OnDragStart", DragStart)
	self:HookScript("OnDragStop", DragStop)
	self:RegisterForDrag("LeftButton")
	if ( not InCombatLockdown() and not self:IsMouseEnabled() ) then
		self:EnableMouse(true)
	end
end

