local frame = CreateFrame("Frame", "EventFrame")
local t = table.get({})

frame:SetScript("OnEvent", function(self, event, ...)
	local script = self[event]
	script(script, event, ...) 
end)

local function EventDispatcher(_, event, ...)
	for _, v in next, t[event] do 
		v(v, event, ...)
	end
end

function RegisterEvent(fct, ...)
	for i = 1, select("#", ...) do
		local event = select(i, ...)
		local script = frame[event]
		if ( not script ) then 
			frame:RegisterEvent(event)
			frame[event] = fct
		elseif ( script ~= fct ) then
			local t = t[event]
			if ( not table.k(t, fct) ) then
				if ( #t == 0 ) then
					frame[event] = EventDispatcher
					table.insert(t, script)
				end
				table.insert(t, fct)
			end
		end
	end
end

function UnregisterEvent(fct, ...)
	for i = 1, select("#", ...) do
		local event = select(i, ...)
		local script = frame[event]
		if ( not script ) then
			return
		elseif ( script == fct ) then
			frame:UnregisterEvent(event)
			frame[event] = nil
		else
			local t = t[event]
			local k = table.k(t, fct)
			if ( k ) then			
				table.remove(t, k)
				if ( #t == 1 ) then 
					frame[event] = t[1]
					table.remove(t, 1)
				end
			end

		end
	end
end

RegisterEvent(function()
	table.get(LibrarySVPC.points)
end, "VARIABLES_LOADED")
