BgColor = {0.25, 0.25, 0.25, 0.25}

LibrarySVPC = {points = {}}
LibrarySV = {}

function NoFunction() end

StaticPopupDialogs["PROMPT"] = {
	button1 = ACCEPT,
	button2 = CANCEL,
	hasEditBox = false,
	timeout = 0,
	exclusive = 1,
	hideOnEscape = 1,
	whileDead = 1,
	enterClicksFirstButton = 1,
}

StaticPopupDialogs["INPUT"] = {
	text = "PerfectBar",
	button1 = ACCEPT,
	button2 = CANCEL,
	hasEditBox = true,
	timeout = 0,
	OnShow = function(self) _G[self:GetName().."EditBox"]:SetText("") end,
	exclusive = 1,
	hideOnEscape = 1,
	EditBoxOnEscapePressed = function(self) self:GetParent():Hide() end,
	whileDead = 1,
	maxLetters = 128,
}

function OpenMe(type, text, fct,  data, data2)
	StaticPopupDialogs[type].OnAccept = fct
	StaticPopupDialogs[type].text = text
	local dialog = StaticPopup_Show(type)
	dialog.data = data
	dialog.data2 = data2
	return dialog
end

function OnEvent(self, event, ...) 
	self[event](self, event, ...) 
end

function HideGameTooltip()
	GameTooltip:Hide()
end

function GetHiddenChild(parent)
	 for _, v in next, {parent:GetChildren()} do
		if ( not v:IsShown() ) then
			return v
		end
	end
	return nil
end

function GetHiddenFrame(name, f, ...)
	local i = 0
	local frame
	repeat
		i = i+1
		frame = _G[name..i]
	until not frame or not frame:IsShown() 
	if ( not frame and f ) then
		return f(name, i, ...)
	else
		return frame, i
	end
end


function GetArenaSize()
	for i=1, MAX_BATTLEFIELD_QUEUES do
		local status, _, _, _, _, size = GetBattlefieldStatus(i)
		if ( status == "active" ) then
			return size
		end
	end
end


function SetStatusBarColorClass(statusbar, unitclass)
	if ( not unitclass ) then unitclass = "WARRIOR"
	end
	statusbar:SetStatusBarColor(RAID_CLASS_COLORS[unitclass].r, RAID_CLASS_COLORS[unitclass].g, RAID_CLASS_COLORS[unitclass].b, 1)
end

function SetStatusBarColorPower(statusbar, power)
	statusbar:SetStatusBarColor(PowerBarColor[power].r, PowerBarColor[power].g, PowerBarColor[power].b, 1)
end

function GetReactionColor(unitid)
	if ( not UnitPlayerControlled(unitid) and UnitIsTapped(unitid) and not UnitIsTappedByPlayer(unitid) ) then
		return 0.5, 0.5, 0.5
	else
		return UnitSelectionColor(unitid)
	end
end


function LoadAddonOnce(k)
	if ( not IsAddOnLoaded(k) ) then
		return LoadAddOn(k)
	end
end





