local r = 140/2+7

local function MoveMe(self)
	local x0, y0 = Minimap:GetCenter()
	local x, y = self:GetCenter()
	local dx = x-x0
	local dy = y-y0
	
	local d = sqrt(dx*dx+dy*dy)


	local c, s = dx/d, dy/d

	self:ClearAllPoints()
	self:SetPoint("CENTER", Minimap, "CENTER", r*c, r*s)
end

local function DragMe(self)
	self:StartMoving()
	self:SetScript("OnUpdate", MoveMe)
end

function NewMinimapButton(name, text, t, texture, f)
	local button = CreateFrame("Button", name, Minimap)

	button:SetPoint("CENTER", Minimap, -r, 0)
	button:SetWidth(32)
	button:SetHeight(32)
	button:SetMovable(true)


	button:RegisterForDrag("LeftButton")
	button:SetScript("OnDragStart", DragMe)
	button:SetScript("OnDragStop", function(self) 
		self:StopMovingOrSizing() 
		self:SetScript("OnUpdate", nil) 
		MoveMe(self)
		SaveFramePosition(self)
	end)
	


	button.displayMode = "MENU"
	button.initialize = EasyMenu_Initialize
	button.SetWidth = NoFunction
	button.SetHeight = NoFunction
	button.dropdown = t

	button:SetScript("OnClick", function(self, b)
		if ( b == "LeftButton" ) then
			ToggleDropDownMenu(1, nil, self, "cursor", nil, nil, self.dropdown)
		end
	end)

	if ( f ) then
		button:RegisterForClicks("LeftButtonUp", "RightButtonUp")
		button:HookScript("OnClick", function(self, b)
			if ( b == "RightButton" ) then
				f()
			end
		end)
	end


	local icon = button:CreateTexture(nil, "OVERLAY", nil, 0)
	if ( texture ) then
		icon:SetPoint("CENTER")
		icon:SetWidth(18)
		icon:SetHeight(18)
		icon:SetTexture(texture)
	else
		icon:SetPoint("TOPLEFT", 2, -4)
		icon:SetWidth(25)
		icon:SetHeight(25)
		icon:SetTexture("Interface\\Minimap\\UI-Minimap-Background")
		icon:SetAlpha(0.6)
	end

	button.icon = icon 


	if ( text ) then
		local fs = button:CreateFontString(nil, "OVERLAY", nil, 1)
		fs:SetFontObject("GameFontNormal")
		fs:SetPoint("CENTER")
		fs:SetText(text)
		button.text = fs
	end

	local border = button:CreateTexture(nil, "OVERLAY", nil, 2)
	border:SetWidth(54)
	border:SetHeight(54)
	border:SetPoint("TOPLEFT")
	border:SetTexture("Interface\\Minimap\\MiniMap-TrackingBorder")
	button:SetHighlightTexture("Interface\\Minimap\\UI-Minimap-ZoomButton-Highlight")
	return button
end








