table.handler = {}

function table.k(t, value)
	for k, v in next, t do
		if ( v == value ) then
			return k
		end
	end
	return nil
end

function table.add(t, value)
	local i = 1
	while t[i] do
		i = i+1
	end
	t[i] = value
	return i
end

local m = {__index = function(self, k) return rawset(self, k, {})[k] end}
function table.get(t)
	return setmetatable(t, m)
end


function table.copy(t, u)
	for k, v in next, t do
		if ( type(v) == "table" and type(v[0]) ~= "userdata" ) then
			u[k] = table.copy(v, {})
		else
			u[k] = v
		end
	end
	return u
end

function table.pack(t, ...)
	wipe(t)
	for i = 1, select('#', ...) do
		t[i] = select(i, ...)
	end
	return t
end

local function FormatMe(k)
	if ( type(k) ~= 'string' ) then
		return tostring(k)
	else
		return "'"..k.."'"
	end
end

function table.handler.setv(handler, value, ...)
	local n = select('#', ...)
	local k = select(n, ...)
	local s = k
	local t = GetManagedEnvironment(handler)
	for i = n-1, 1, -1 do
		if ( not t[k] ) then handler:Execute(s.." = newtable()")
		end
		t = t[k]
		k = select(i, ...)
		s = s..'['..FormatMe(k)..']'
	end
	if  ( type(value) ~= "table") then
		handler:Execute(s.." = "..FormatMe(value))
	elseif ( type(value[0]) == "userdata" ) then
		handler:SetFrameRef('frame', value)
		handler:Execute(s.." = self:GetFrameRef('frame')")
	else
		print("wrong value.")
	end
end

function table.handler.copy(handler, t, ...)
	for k, v in next, t do
		if ( type(v) == "table" and type(v[0]) ~= "userdata" ) then
			table.handler.copy(handler, v, k, ...)
		else
			table.handler.setv(handler, v, k, ...)
		end
	end
end
