local addon, w = ...
local petbar = _G[addon.."PetBar"]



petbar:SetPoint("CENTER", UIParent, "CENTER")

petbar:Hide()


local bg = petbar:CreateTexture()
bg:SetTexture(unpack(BgColor))
bg:SetAllPoints(petbar)
petbar.bg = bg

RegisterForAnchor(petbar, petbar, true)

local function UpdateCooldown(button, action)
	local start, duration, enable = GetPetActionCooldown(action)
	if ( start > 0 and duration > 0 and enable > 0 ) then
		button.cooldown:SetCooldown(start, duration)
		button.cooldown:Show()
	else
		button.cooldown:Hide()
	end
end

local function RemapMe(i)
	if ( i < 8 ) then
		return i
	elseif ( i > 8 ) then
	 	return i-1
	else
		for j = 8, 10 do
			if ( select(5, GetPetActionInfo(j)) ) then
				return j
			end
		end
		return 8
	end
end

local function UpdatePetBar(self)
	for i = 1, 11 do
		local button = _G[self:GetName().."Button"..i]
		local name, subtext, texture, token, active, autocastallowed, autocastenabled = GetPetActionInfo(RemapMe(i))

		if ( token ) then
			texture = _G[texture]
			button.tooltip = _G[name]
			button:SetAlpha(1)
		else
			if ( name ) then
				button.tooltip = nil
				button:SetAlpha(1)
			else
				button.tooltip = "Action pet "..string.color(i, "ffff00")
				button:SetAlpha(0.25)
			end
		end
		if ( not InCombatLockdown() ) then
			if ( autocastallowed ) then
				button:SetAttribute("type2", "macro")
				button:SetAttribute("macrotext2", "/petautocasttoggle "..name)	
			else
				button:SetAttribute("type2", nil)
			end
		end
		button.icon:SetTexture(texture)
		if ( autocastenabled) then
			AutoCastShine_AutoCastStart(_G[button:GetName().."Shine"])
		else
			AutoCastShine_AutoCastStop(_G[button:GetName().."Shine"])
		end
		if (  active ) then
			button.state:Show()
		else
			button.state:Hide()
		end
		UpdateCooldown(button, i)
	end
end

petbar:SetScript("OnHide", function(self)
	self:UnregisterEvent("UNIT_PET")
	self:UnregisterEvent("UNIT_FLAGS")
	self:UnregisterEvent("PET_BAR_UPDATE")
	self:UnregisterEvent("PET_BAR_UPDATE_COOLDOWN")
	self:UnregisterEvent("PLAYER_ENTERING_WORLD")
	self:UnregisterEvent("PLAYER_CONTROL_LOST")
	self:UnregisterEvent("PLAYER_CONTROL_GAINED")
	self:UnregisterEvent("UNIT_AURA")

	if ( WonderBarOptions.chat ) then
		local point, frame, relative, x, y = ChatFrame1:GetPoint()
		ChatFrame1:SetPoint(point, frame, relative, x, y-self:GetHeight())
	end
end)

petbar:SetScript("OnShow", function(self)
	self:RegisterEvent("UNIT_PET")
	self:RegisterEvent("UNIT_FLAGS")
	self:RegisterEvent("PET_BAR_UPDATE")
	self:RegisterEvent("PET_BAR_UPDATE_COOLDOWN")
	self:RegisterEvent("PLAYER_ENTERING_WORLD")
	self:RegisterEvent("PLAYER_CONTROL_LOST")
	self:RegisterEvent("PLAYER_CONTROL_GAINED")
	self:RegisterEvent("UNIT_AURA")
	UpdatePetBar(self)
	if ( WonderBarOptions.chat ) then
		local point, frame, relative, x, y = ChatFrame1:GetPoint()
		ChatFrame1:SetPoint(point, frame, relative, x, y+self:GetHeight())
	end
end)

petbar:SetScript("OnEvent", function(self, event, unitid)
	if ( event == "PET_BAR_UPDATE_COOLDOWN" ) then
		for i = 1, 11 do
			UpdateCooldown(_G[self:GetName().."Button"..i], RemapMe(i))
		end
	elseif ( not unitid ) or ( event == "UNIT_PET" and unitid == "player" ) or ( unitid == "pet" ) then
		UpdatePetBar(self)
	end
end)
