﻿local addon, w = ...

WonderBar = {}
WonderBarOptions = {}
WonderBarBinds = {}

local buttons = {}
local icons = {}
local actions = {}


WonderBarButtons = buttons
WonderBarActions = actions
WonderBarIcons = icons


SHADOW_DANCE = GetSpellInfo(51713)
STEALTH_CAT = GetSpellInfo(5215)
STEALTH_ROGUE = GetSpellInfo(1784)


CONFIG_PETBAR = {geo = {size = 36, space = 2, lines = 1, columns = 11} }


local petbar = CreateFrame("Frame", addon.."PetBar", UIParent, "SecureFrameTemplate")


local handler = CreateFrame("Button", "WonderBarHandler", UIParent, "SecureHandlerStateTemplate" )--, SecureHandlerClickTemplate")


--, SecureHandlerShowHideTemplate


handler.setv = table.handler.setv
handler.copy = table.handler.copy



SLASH_CLEARACTIONS1 = "/clearactions"
SlashCmdList["CLEARACTIONS"] = function() 
	OpenMe("PROMPT", "Voulez vous supprimez toutes les actions ?", function()
		for i=1, 120 do
			PickupAction(i)
			ClearCursor()
		end
	end)
end

local function FindStance(stance, state)
	for i = 1, GetNumShapeshiftForms() do
		if ( stance == select(2, GetShapeshiftFormInfo(i)) ) then
			if ( stance ~= SHADOW_DANCE ) then
				return "[stance:"..i.."] "..state..";" 
			else
				return "[bonusbar:2] "..state..";"
			end
		end
	end
end

function handler:HideAction(action)
	actions[action] = nil
	icons[action]:Hide()
end

function handler:ShowAction(action)
	icons[action]:Show()
	local button = buttons[action]
	button.action = action

	_G[button:GetName().."Icon"] = icons[action]

	w.UpdateButton(button, action)
end

handler:Execute([==[update = [[
	local bar, newstate = ...
	local t = bars[bar]
	local state = t.state
	if ( state ~= newstate ) then
		if ( state ~= '' ) then
			for k, v in next, t.actions[state] do
				 control:CallMethod("HideAction", v) 
			end
		end
		if ( newstate ~= '' ) then
			for k, v in next, t.actions[newstate] do 
				t.buttons[k]:SetAttribute("action", v) 
				control:CallMethod("ShowAction", v)
			end

			t.bar:Show(true)
	
		else
			t.bar:Hide(true)
		end

		t.state = newstate
	end
]]]==])



handler:Execute([[
	scripts = newtable()
	units = newtable()
	modifiers = newtable()
	bars = newtable()
]])


local OnStanceChanged = [[
	control:Run(update, stateid, newstate)
]]


handler:Execute([==[modifier = [[
	local key = ...
	local m = modifiers[key]
	if ( m ) then
		for bar, v in next, m do
			local mods = bars[bar].modifiers[key]
			local i 
			if ( v ) then
				if ( v < #mods ) then
					i = v+1
				else
					i = 1
				end	
				m[bar] = i			
			else
				i = 1
			end
			local s = mods[i]
			if ( s ~= "options" ) then
				control:Run(update, bar, s)
			else
				control:Run(update, bar, self:GetAttribute('state-'..bar))
			end
		end
	end
]]]==])

handler:Execute([==[unit = [[
	local key = ...
	local u = units[key]
	if ( u ) then
		for bar, unit in next, u do
			bars[bar].bar:SetAttribute("unit", unit)
		end
	end
]]]==])



handler:Execute([==[scripts['true'] = [[
	control:Run(unit, ...)
	control:Run(modifier, ...)
]]]==])



handler:Execute([==[scripts['false'] = [[
	local key = ...
	local m = modifiers[key]
	if ( m ) then
		for bar, v in next, m do
			if ( not v ) then
				control:Run(update, bar, self:GetAttribute('state-'..bar))
			end
		end
	end
]]]==])



local OnModifierChanged = [[
	control:Run(scripts[newstate], stateid)
]]


function CompileGeo(bar, t)
	t = t.geo

	local frame = _G[bar]
	local size = t.size
	local space = t.space
	local s = size+space

	local l = t.lines
	local c = t.columns

	local n
	local a 
	local r 

	if ( t.circle ) then
		frame:SetWidth(size) 
		frame:SetHeight(size)	
		n = l*c
		a = 360/n
		r = s/tan(a)
	else
		if ( bar ~= addon.."PetBar" ) then
			frame:SetWidth(c*s-space) 
		else
			frame:SetWidth(8*s-space) 
		end
		frame:SetHeight(l*s-space)
	end

	for i = 1, l*c do
		local button = _G[bar.."Button"..i] or w.NewButton(frame, i)
		button:SetWidth(size)
		button:SetHeight(size)


		button:ClearAllPoints()

		if ( bar == addon.."PetBar" ) then
			button.icon:SetWidth(size*(t.icon or 0.85))
			button.icon:SetHeight(size*(t.icon or 0.85))


			_G[button:GetName().."Shine"]:SetHeight(size*(t.icon or 0.85))
			_G[button:GetName().."Shine"]:SetWidth(size*(t.icon or 0.85))
		else
			button:Show()
		end

		if ( t.circle ) then
			button:SetPoint("CENTER", frame, "CENTER", r*cos((i-1)*a), r*sin((i-1)*a))
		else
			button:SetPoint("BOTTOMLEFT", frame, "BOTTOMLEFT", ((i-1)%c)*s, floor((i-1)/c)*s)
		end
	end
end


local function NewMe(bar, i, action, t)
		local button = _G[bar.."Button"..i] 
		local s = button:GetWidth()
		buttons[action] = button

		local icon = icons[action] or button:GetParent():CreateTexture(nil, "OVERLAY", 0)
		icon:SetTexCoord(0.07, 0.93, 0.07, 0.93)

		icon:ClearAllPoints()
		icon:SetParent(button:GetParent())
		
		icon:SetPoint("CENTER", button, "CENTER")
		icon:SetTexture(GetActionTexture(action))



		icons[action] = icon
		icon:Hide()
		icon:SetWidth(s*(t.geo.icon or 0.85))
		icon:SetHeight(s*(t.geo.icon or 0.85))

end

function CompileActions(bar, t)
	local n = t.geo.lines*t.geo.columns
	local b = bar:lower()

	for state, actions in next, t.actions do
		for i = 1, n do
			NewMe(bar,i, actions[i], t)

		end
	end
	if ( t.stances.pos ) then
		for i = 1, n do
			local action = i+120
			NewMe(bar,i , action)
			handler:setv(action, i, 'pos', 'actions', b, 'bars')
		end
	end
	handler:copy(t.actions, 'actions', b, 'bars')
end

function CompileModifiers(bar, t)
	local b = bar:lower()
	for k, v in next, t.modifiers do
		local type 
		if ( #v > 1 ) then
			type = 0
		else
			type = false
		end
		handler:setv(type, b, k, 'modifiers')
	end

	handler:copy(t.modifiers, 'modifiers', b, 'bars')
end

function CompileStances(bar, t)
	local text = ""
	local state
	t = t.stances


	state = t.Harmful
	if ( state ) then
		text = text.."[harm] "..state..";"
	end

	state = t.Helpful
	if ( state ) then
		text = text.."[help] "..state..";"
	end

	if ( t.pos  ) then
		text = text.."[bonusbar:5] pos;"
	end

	--BESOIN POUR VANISH
	state = t[STEALTH_CAT] or t[STEALTH_ROGUE]
	if ( state ) then
		text = "[stealth] "..state..";"
	end


	for k, v in next, t do
		text = text..(FindStance(k,v) or '')
	end

	state = t[UnitRace("player")]
	if ( state  ) then
		text = text..state
	end

	RegisterStateDriver(handler, bar:lower(), text)

end

function CompileUnits(bar, t)
	local b = bar:lower()
	for k, v in next, t.units do
		if ( v == "target" ) then v = nil end
		handler:setv(v, b, k, 'units')
	end
end
	
function WonderBarNewBar(bar)
	local frame = CreateFrame("Frame", bar,  handler, "SecureFrameTemplate")
	local b = bar:lower()

	handler:setv('', 'state', b, 'bars')
	handler:setv(frame, 'bar', b, 'bars')

	local bg = frame:CreateTexture()
	bg:SetTexture(unpack(BgColor))
	bg:SetAllPoints(frame)
	frame.bg = bg

	RegisterForAnchor(frame, frame, true)
	frame:SetPoint("CENTER", UIParent, "CENTER")

	handler:SetAttribute("_onstate-"..b, OnStanceChanged)

	return frame
end

function WonderBar_UpdateExpBar()
	if ( WonderBarOptions.xp ) then
		MainMenuExpBar:SetParent(MainMenuBar)
	else
		MainMenuExpBar:SetParent(UIParent)
	end
end

	
RegisterEvent(function()
	for bar, t in next, WonderBar do

		WonderBarNewBar(bar)
		CompileGeo(bar, t)
		CompileActions(bar, t)
		CompileStances(bar, t)
		CompileModifiers(bar, t)
		CompileUnits(bar, t)
	end
	CompileGeo(addon.."PetBar", CONFIG_PETBAR)

	RegisterStateDriver(_G[addon.."PetBar"], "visibility", "[target=pet,exists, nobonusbar:5] show; hide;")


	if ( WonderBarOptions.range ) then
		RegisterEvent(RangeIndicatorOnEvent, "PLAYER_TARGET_CHANGED")
	end
	if ( WonderBarOptions.lock ) then
		handler:Execute("lock = true")
	end

	WonderBar_UpdateExpBar()

	if ( eTools ) then
		eTools:SetParent(eBankBar)
	end
end, "VARIABLES_LOADED")

RegisterEvent(function()
	for k, v in next, WonderBar do
		CompileStances(k, v)
	end
end, "UPDATE_SHAPESHIFT_FORMS")



RegisterStateDriver(handler, "visibility", "[vehicleui] hide; show")


w.OnModifierChanged = OnModifierChanged

