﻿local addon, w = ...

local function RemoveMe(action)
	WonderBarButtons[action] = nil
	WonderBarHandler.HideAction(nil, action)
end


function w:AddActions()	
	local t = self.datas
	local actions = t.actions
	local l = t.geo.lines*t.geo.columns
	local b = self.current:lower()
	for state, _ in next, self.states do
		local a = actions[state] or {}
		for i = #a+1, l do
			a[i] = table.add(WonderBarButtons, true)
		end
		actions[state] = a
	end
	w.saved = false
end



function w:DelActions()
	local t = self.datas
	local actions = t.actions
	local l = t.geo.lines*t.geo.columns+1
	local b = self.current:lower()


	WonderBarHandler:SetAttribute('state-'..b, '')
	WonderBarHandler:setv(nil, 'actions', b, 'bars')

	for state, a in next, actions do
		if ( self.states[state] ) then
			for i = l, #a do
				RemoveMe(a[i])
				a[i] = nil
			end
		else
			for k, v in next, a do
				RemoveMe(v)
			end
			actions[state] = nil
		end
	end
end

function w:DelButtons(bar, n)
	for i = n, _G[bar]:GetNumChildren() do
		local button = _G[bar.."Button"..i]
		local k = table.k(WonderBarBinds, button:GetName())
		if ( k ) then
			SetOverrideBinding(button, true, k) 
			WonderBarBinds[k] = nil
		end
		button:Hide()
	end
end

