local addon, w  = ...

local frame_geo = w.NewFrame("Geo", "Geometry")
local size = CreateFrame("Slider", frame_geo:GetName().."Size", frame_geo, "OptionsSliderTemplate")
local space = CreateFrame("Slider", frame_geo:GetName().."Space", frame_geo, "OptionsSliderTemplate")
local button_circle = CreateFrame("CheckButton", addon.."Circle", frame_geo, "OptionsSmallCheckButtonTemplate")
local icon = CreateFrame("Slider", frame_geo:GetName().."Icon", frame_geo, "OptionsSliderTemplate")





local box = w.NewBox(frame_geo)
local geo = w.datas.geo

w.frame_geo = frame_geo

frame_geo:SetHeight(195)




local function f(self, k)
	if ( InCombatLockdown() ) then w.stop() return end
	local value = tonumber(_G[self:GetName().."EditBox"]:GetText())
	if ( value ) then
		geo[k] = value

		frame_geo:UpdateBox()
		w.number:Update()



		w:DelActions()
		w:AddActions()
		w:DelButtons(w.current, w.datas.geo.lines*w.datas.geo.columns+1)

		CompileGeo(w.current, w.datas)
		CompileActions(w.current, w.datas)

	end
end

box.value = function(self, k)
	local dialog = OpenMe("INPUT", "Set "..k.." to :", f, k)
	_G[dialog:GetName().."EditBox"]:SetText(geo[k])
end


function frame_geo:UpdateBox()
	local text 
	if ( w.current == w.parent_addon.."PetBar" ) then
		text = ""
	else
		text = "Your bar has "..string.link(geo.lines.." lines", "value", "lines", "00ffff").." and "..string.link(geo.columns.." columns", "value", "columns", "00ffff")
	end
	self.box:SetText(text)
end

function frame_geo:UpdateFrame()
	self:UpdateBox()
	size:SetValue(geo.size)
	space:SetValue(geo.space)
	button_circle:SetChecked(geo.circle)

	icon:SetValue(geo.icon or 0.85)
end

local function UpdateIconScale()
	local n = geo.lines*geo.columns
	local size = geo.size
	for state, actions in next, w.datas.actions do
		for i = 1, n do
			local action
			if ( state ~= 'pos' ) then
				action = actions[i]
			else
				action = i+120
				
			end
			local icon = WonderBarIcons[action] 
			icon:SetWidth(size*(geo.icon or 0.85))
			icon:SetHeight(size*(geo.icon or 0.85))
			
		end
	end
end


local function GeoMe(self, value)
	if ( InCombatLockdown() ) then w.stop() return end
	local k = self.k
	if ( value ~= geo[k] ) then
		if ( k == "icon" ) then
			value = math.round(value, 2)
		end
		geo[k] = value
		CompileGeo(w.current, w.datas)

		local petbar = w.parent_addon.."PetBar"
		if ( w.current == petbar ) then

			CONFIG_PETBAR.geo[k] = value
		else
			UpdateIconScale()
			w.saved = false
		end
		
	end

	_G[self:GetName().."Text"]:SetText(self.k.." : "..string.color(value, "88ff88"))
end


size:SetPoint("TOPLEFT", 20, -25-12-25-10)
size:SetValueStep(1)
size:SetMinMaxValues(4, 64)
size.k = "size"
size:SetScript("OnValueChanged", GeoMe)

local fs = _G[size:GetName().."Text"]
fs:ClearAllPoints()
fs:SetPoint("BOTTOMLEFT", size, "TOPLEFT", 144/3, 0)




space:SetPoint("TOPLEFT", w.frame_parent:GetWidth()-144-20, -25-12-25-10)
space:SetValueStep(1)
space:SetMinMaxValues(0, 64)
space.k = "space"
space:SetScript("OnValueChanged", GeoMe)

local fs = _G[space:GetName().."Text"]
fs:ClearAllPoints()
fs:SetPoint("BOTTOMLEFT", space, "TOPLEFT", 144/3, 0)



local function CircleMe(self)
	if ( InCombatLockdown() ) then w.stop() return end
	local v = self:GetChecked()
	if ( w.current == w.parent_addon.."PetBar" ) then
		CONFIG_PETBAR.geo.circle = v
	end
	w.datas.geo.circle = v
	CompileGeo(w.current, w.datas)
end

button_circle:SetPoint("BOTTOMLEFT",5, 45)
button_circle:SetScript("OnClick", CircleMe)
_G[button_circle:GetName().."Text"]:SetText("Make your bar circle")




icon:SetPoint("BOTTOMLEFT", 20, 15)
icon:SetValueStep(0.01)
icon:SetMinMaxValues(0.5, 1.5)
icon.k = "icon"
icon:SetScript("OnValueChanged", GeoMe)

local fs = _G[size:GetName().."Text"]
fs:ClearAllPoints()
fs:SetPoint("BOTTOMLEFT", size, "TOPLEFT", 144/3, 0)









frame_geo:Hide()





