﻿local addon, w  = ...
local frame_modifiers = w.NewFrame("Modifiers", "Modifiers")
local box = w.NewBox(frame_modifiers)
local modifiers = w.datas.modifiers
w.frame_modifiers = frame_modifiers

local types = {"switch", "hold"}



local function AddMe(k, i)
	local state = w:NextState()
	local t = modifiers[k] or {}
	modifiers[k] = t
	table.insert(t, i, state)
	w:AddState(state)
	frame_modifiers:UpdateFrame()
end






local button = CreateFrame("Button", frame_modifiers:GetName().."Button", frame_modifiers, "UIPanelButtonTemplate2")
button:SetPoint("LEFT", frame_modifiers.header, "RIGHT", 10, 0)
button:SetText("New modifier")
button:SetWidth(100)

function w.CheckVirtualButtons(t)
	for k, v in rtable.next, GetManagedEnvironment(WonderBarHandler)[t] do
		if ( not rtable.next(v) ) then
			SetOverrideBinding(_G["WonderBarVirtualButton"..k], false, k)
		end
	end
end

function w:DelModifiers()
	local b = self.current:lower()
	WonderBarHandler:Execute([[
		for k, v in next, modifiers do
			v[']]..b..[['] = nil
		end
	]])
	w.CheckVirtualButtons("modifiers")
	WonderBarHandler:setv(nil, 'modifiers', b, 'bars')
end


function frame_modifiers:UpdateFrame(update)
	local text = ""
	local m = 0
	for k, v in next, modifiers do
		local n = #v
		local method 
		if ( n > 1 ) then
			method = "scroll"
		else
			method = "switch"
		end
		text = text.."Press "..string.link(k, "key", k, "00ffff").." to "..method:color("88ff88").." your bar in "
	
		for i = 1, n do
			text = text..string.link(w.FormatState(v[i]), "statedropdown", k..";"..i, "00ffff")
			if ( i < n) then
				text = text..", "
			end
		end
		text = text.." - "..string.link("remove", "del", k, "ff0000").."\n"
		m = m+1
	end

	if ( update ) then

		w:DelActions()
		w:DelModifiers()
		w:AddActions()

		CompileGeo(w.current, w.datas)
		CompileActions(w.current, w.datas)
		CompileModifiers(w.current, w.datas)
		CompileVirtualButtons(modifiers)
	
	end
	self.box:SetText(text)
	self:SetHeight(m*14+35)
end


box.state = function(_, state, c, _, parent)
	if ( InCombatLockdown() ) then w.stop() return end
	local k, i = c:pop(";")
	i = tonumber(i)

	if ( state == "Add state" ) then

		AddMe(k, i+1)
	elseif ( state == "Remove state" ) then
		local t = modifiers[k]
		w:RemoveState(t[i])
		table.remove(t, i)
		if ( #t == 0 ) then
			modifiers[k] = nil
		end
	else
	
		state = w:SelectState(state)

		w:RemoveState(modifiers[k][i])
		w:AddState(state)
		modifiers[k][i] = state
		
	end
	frame_modifiers:UpdateFrame(true)
	parent:Hide()
end


local function f(dialog, old, new)
	if ( InCombatLockdown() ) then w.stop() return end
	if ( not new ) then
		return
	end
	if ( not old ) then
		AddMe(new, 1)
	else
		if ( modifiers[new] ) then
			print(new:color("88ff88").." is already taken.")
		else
			modifiers[new] = modifiers[old]
			modifiers[old] = nil
		end
		
	end

	frame_modifiers:UpdateFrame(true)
end


local function SetKey(dialog, key)
	if ( key and key ~= "" and key ~= "ENTER" and key ~= "ESCAPE" and key ~= "LeftButton" and key ~= "RightButton" ) then
		key = CatchKey(key)
		dialog.data2 = key
		_G[dialog:GetName().."Text"]:SetText("Press a Key : "..key:color("88ff88").."|nClick in this box for mouse button.")
	end
end


w.BindingBox = function(f, value)
	if ( value ~= "LeftButton" ) then
		key = value:color("88ff88")
	else
		key = ""
		value = nil
	end
	local dialog = 	OpenMe("PROMPT", "Press a Key : "..key.."|nClick in this box for mouse button.", f, value)
	dialog:HookScript("OnKeyDown", SetKey)
	dialog:SetScript("OnMouseUp", SetKey)
	dialog:HookScript("OnMouseWheel", SetKey)
	dialog:EnableMouseWheel(true)
end

box.key = function(_, value) w.BindingBox(f, value) end






local function RemoveMe(_, k)
	
	if ( InCombatLockdown() ) then w.stop() return end
	for _, v in next, modifiers[k] do
		w:RemoveState(v)
	end
	modifiers[k] = nil
	frame_modifiers:UpdateFrame(true)
end

box.del = function(self, value)
	OpenMe("PROMPT", "Remove this modifier ?", RemoveMe, value)
end

button:SetScript("OnClick", box.key)

