local addon, w  = ...

w.stop = function() print(string.color("No configuration in combat.", "ff0000")) end

w.datas = {
	geo = {},
	actions = {},
	modifiers = {}, 
	stances = {},
	units = {}
}

w.states = {}
w.t = {}



function w.ShowGameTooltip(self)
	GameTooltip:SetOwner(self, "ANCHOR_CURSOR")
	GameTooltip:SetText(self.tooltip, 1.0, 1.0, 1.0)
	GameTooltip:Show()
end

w.ESUpdateDropDown = function(...)
	local d = ESUpdateDropDown(...)
	d.timer = 3
	TimerInit(d, d.Hide, d.timer) 
end



local ground = "Stance Bar"

local frame_parent = CreateFrame("Frame", addon.."FrameParent", UIParent)
frame_parent:RegisterForDrag("LeftButton")
frame_parent:Hide()



frame_parent:SetPoint("CENTER")
frame_parent:SetWidth(380)
frame_parent:SetHeight(110)
RegisterForAnchor(frame_parent, frame_parent, true)

local bg = frame_parent:CreateTexture(nil, "BACKGROUND")
bg:SetAllPoints(frame_parent)
bg:SetTexture(unpack(BgColor))

w.frame_parent = frame_parent


function w.NewFrame(name, header)
	local frame = CreateFrame("Frame", addon.."Frame"..name, frame_parent )--"UIPanelScrollFrameTemplate"

	local bg = frame:CreateTexture(nil, "BACKGROUND")
	bg:SetAllPoints(frame)
	bg:SetTexture(unpack(BgColor))

	local fs = frame:CreateFontString()
	fs:SetFontObject("GameFontNormal")
	fs:SetPoint("TOPLEFT", 5, -10)
	fs:SetText(header)
	frame.header = fs
	frame:SetPoint("TOPLEFT", frame_parent, "BOTTOMLEFT",0, 2)
	frame:SetPoint("TOPRIGHT", frame_parent, "TOPRIGHT", 0, 2)
	
	


	frame:SetBackdrop({edgeFile = "Interface\\ChatFrame\\ChatFrameBackground", edgeSize = 2})
	frame:SetBackdropBorderColor(0, 0, 0)

	frame:Hide()
	return frame
end


function w:NextState()
	local i = 1
	while self.states[i] do
		i = i+1
	end
	return i
end

function w:RemoveState(state)
	local states = self.states
	if ( state ) then
		local n = states[state]
		if ( n and n > 1 ) then
			states[state] = n-1
		else
			states[state] = nil
		end
	end
	self.number:Update()
end

function w:AddState(state)
	local states = self.states
	if ( type(state) == "number" ) then
		local n = states[state]
		if ( n ) then
			states[state] = n+1
		else
			states[state] = 1
		end
		self.number:Update()
	end
end

function w:SelectState(value)
	local state
	if     ( value == "New page" ) then
		state = self:NextState()
	elseif ( value == "Stance bar" ) then
		state = "options"
	elseif ( value == "Hide the Bar" ) then
		state = ''
	else
		state = tonumber(value:match("%d"))
	end
	return state
end

function w.FormatState(state)
	    if ( type(state) == "number" ) then
		return "page "..state
	elseif ( state == '' ) then
		return "hidden state"
	elseif ( state == "options" ) then
		return "stance bar"
	end
end

local function StateDropDown(self, value)
	local t = w.t
	wipe(t)
	for k, v in next, w.states do
		table.insert(t, "page "..k)
	end

	table.insert(t, "page "..w:NextState().." (new)")
	
	t["Special"] = {"Hide the Bar"}
	if ( self ==  w.frame_modifiers.box ) then
		t["Functions"] = {"Add state", "Remove state"} 
		t["Special"][2] = "Stance bar"
	end
	w.ESUpdateDropDown(t, self.state, "CURSOR", 1, value)
end


local function f(self, link, text, button)
	local type, value = link:pop(":")
	self[type](self, value)
end

function w.NewBox(frame)
	local box = CreateFrame("SimpleHTML", nil, frame)

	box:SetFontObject("ChatFontNormal")
	box:SetJustifyH("LEFT") 
	box:SetJustifyV("TOP") 
	box:SetScript("OnHyperlinkClick", f)
	
	box:SetHeight(12)

	box:SetWidth(frame_parent:GetWidth()-10)

	box:SetPoint("TOPLEFT", 5, -25)

	box.statedropdown = StateDropDown
	frame.box = box
	return box
end





local border = CreateFrame("Frame", nil, frame_parent)
border:SetBackdrop({edgeFile = "Interface\\ChatFrame\\ChatFrameBackground", edgeSize = 2})
border:SetBackdropBorderColor(0, 0, 0)
border:SetAllPoints(frame_parent)
border:SetFrameLevel(4)





