﻿local addon, w  = ...
local frame_stances = w.NewFrame("Stances", "Stances/Shapeshift")
local button_pos = CreateFrame("CheckButton", addon.."Pos", frame_stances, "OptionsSmallCheckButtonTemplate")
local box = w.NewBox(frame_stances)
local stances = w.datas.stances
w.frame_stances = frame_stances


local function TextMe(prefix,name)
	local text = prefix..name:color("88ff88").." this bar display "
	state = stances[name]
	if ( state ) then
		text = text.."the "..string.link(w.FormatState(state), "statedropdown", name, "00ffff").." - "..string.link("remove", "del", name, "ff0000").."\n"
	else
		text = text..string.link("nothing", "statedropdown", name, "00ffff").."\n"
	end
	return text
end

function frame_stances:UpdateFrame(update)
	local box = self.box
	local text = ""	
	local n = GetNumShapeshiftForms()
	local state
	
	text = text..TextMe("While in ",UnitRace("player"))
	for i = 1, n do
		text = text..TextMe("While in ", select(2, GetShapeshiftFormInfo(i)))
	end

	if ( select(2, UnitClass("player")) == "DRUID" ) then
		text = text..TextMe("While in ", STEALTH_CAT)
		n = n+1
	end
	text = text.."\n"
	text = text..TextMe("When your target is ","Harmful")
	text = text..TextMe("When your target is ","Helpful")

	n = n+3
	box:SetText(text)
	self:SetHeight(14*(n+3)+35+10)

	if ( update ) then
		w:DelActions()
		w:AddActions()

		CompileGeo(w.current, w.datas)
		CompileActions(w.current, w.datas)
		CompileStances(w.current, w.datas)

	
	end
	button_pos:SetChecked(stances.pos)
end


box.state = function(_, value, i, _, parent)
	if ( InCombatLockdown() ) then w.stop() return end
	local state = w:SelectState(value)
	w:RemoveState(stances[i])
	w:AddState(state)
	stances[i] = state
	frame_stances:UpdateFrame(true)
	parent:Hide()
end


local function f(self, value)
	if ( InCombatLockdown() ) then w.stop() return end
	w:RemoveState(stances[value])
	stances[value] = nil
	frame_stances:UpdateFrame(true)
end

box.del = function(self, value)
	OpenMe("PROMPT", "Don't change your bar in this Stance/Shapeshift ?", f, value)
end


RegisterEvent(function() frame_stances:UpdateFrame() end, "UPDATE_SHAPESHIFT_FORMS")

button_pos:SetPoint("BOTTOMLEFT", 5, 5)
_G[button_pos:GetName().."Text"]:SetText("Use bindings of this bar for your "..string.color("vehicule","88ff88"))
button_pos:SetScript("OnCLick", function(self)

	if ( InCombatLockdown() ) then w.stop() return end

	stances['pos'] = self:GetChecked()

	WonderBarHandler:SetAttribute('state-'..w.current:lower(), '')
	WonderBarHandler:setv(nil, 'actions', w.current:lower(), 'bars')

	CompileActions(w.current, w.datas)
	CompileStances(w.current, w.datas)
	w.saved = false
end)


