local addon, w = ...
w.parent_addon = addon:pop("_")

local frames = { w.frame_geo,  w.frame_stances, w.frame_modifiers, w.frame_units}
local tabs = {}
local x = 3
w.tabs = tabs



function w.TabMe(self)
	for k, v in next, frames do
		local tab = tabs[k]
		if ( not w.current ) or ( self and self ~= tab ) or ( w.current == w.parent_addon.."PetBar" and v ~= w.frame_geo )  then
			v:Hide()
			tab:SetChecked(false)
		elseif ( tab:GetChecked() ) then
			v:UpdateFrame()
			v:Show()
		else
			v:Hide()
		end
	end

end

for k, v in next, frames do

	local tab = CreateFrame("CheckButton", nil, w.frame_parent)
	tabs[k] = tab
	tab:SetPoint("BOTTOMLEFT", w.frame_parent, "TOPLEFT", x, -2)

	local fs = tab:CreateFontString(nil, "OVERLAY")
	fs:SetFontObject("GameFontNormalSmall")
	fs:SetPoint("CENTER")
	fs:SetText(v.header:GetText())
	tab.fs = fs

	tab:SetScript("OnEnter", function(self) self.fs:SetFontObject("GameFontHighlightSmall") end)

	tab:SetScript("OnLeave", function(self) self.fs:SetFontObject("GameFontNormalSmall") end)




	tab:SetBackdrop({edgeFile = "Interface\\ChatFrame\\ChatFrameBackground", edgeSize = 2})
	tab:SetBackdropBorderColor(0, 0, 0)


	local s = fs:GetStringWidth()+12
	tab:SetWidth(s)
	tab:SetHeight(16)
	

	local bg = tab:CreateTexture(nil, "BACGROUND")


	--bg:SetTexture("Interface\\SPELLBOOK\\UI-SpellBook-Tab-Unselected")
	--bg:SetRotation(PI)
	--bg:SetHeight(48)
	--bg:SetWidth(96)
	--bg:SetPoint("CENTER")

	bg:SetAllPoints(tab)
	bg:SetTexture(unpack(BgColor))



	tab:SetCheckedTexture("Interface\\PaperDollInfoFrame\\UI-Character-Tab-Highlight")
	--tab:SetHighlightTexture("Interface\\PaperDollInfoFrame\\UI-Character-Tab-Highlight")







	tab:SetScript("OnClick", w.TabMe)
	x = x+s+4
end


