local addon, w  = ...
local frame_units = w.NewFrame("Units", "Units")
local box = w.NewBox(frame_units)
local units = w.datas.units
local unitlist = {"focus", "player", "target", "pet", "Enter a name"}
w.frame_units = frame_units

function w:DelUnits()
	local b = self.current:lower()
	WonderBarHandler:Execute([[
		for _, v in next, units do
			v[']]..b..[['] = nil
		end
	]])

	_G[w.current]:SetAttribute("unit", nil)
	w.CheckVirtualButtons("units")

	--WonderBarHandler:setv(nil, 'units', b, 'bars')
end

function frame_units:UpdateFrame(update)
	local text = ""
	local n = 0
	for k, v in next, units do
		n = n+1
		text = text.."Press "..k:link("key", k, "00ffff").." to cast actions to "..v:link("unit", k, "00ffff").." - "..string.link("remove", "del", k, "ff0000").."\n"
	end
	self.box:SetText(text)
	self:SetHeight(n*14+35)
	if (update) then
		w:DelUnits()
		CompileUnits(w.current, w.datas)
		CompileVirtualButtons(units)
		w.saved = false
	end
end


local button = CreateFrame("Button", frame_units:GetName().."Button", frame_units, "UIPanelButtonTemplate2")
button:SetPoint("LEFT", frame_units.header, "RIGHT", 15, 0)
button:SetText("New unit")
button:SetWidth(100)

local function f(_, old, new)
	if ( InCombatLockdown() ) then w.stop() return end
	if ( not new ) then
		return
	end
	if ( not old ) then
		units[new] = 'none'
	else
		if ( units[new] ) then
			print(new:color("88ff88").." is already taken.")
		else
			units[new] = units[old]
			units[old] = nil
		end
		
	end
	frame_units:UpdateFrame(true)
end


box.key = function(_, value)  w.BindingBox(f, value) end
button:SetScript("OnClick",box.key)



local function NameMe(dialog, k)
	units[k] = _G[dialog:GetName().."EditBox"]:GetText()
	frame_units:UpdateFrame(true)
end

local function SelectUnit(_, value, k)
	if ( InCombatLockdown() ) then w.stop() return end
	if ( value ~= "Enter a name" ) then
		units[k] = value
		frame_units:UpdateFrame(true)
	else
		OpenMe("INPUT", "Enter a name", NameMe, k)
	end

end

box.unit = function(self, value)
	w.ESUpdateDropDown(unitlist, SelectUnit, "CURSOR", 1, value)
end

local function f(_, k)
	if ( InCombatLockdown() ) then w.stop() return end
	units[k] = nil
	frame_units:UpdateFrame(true)
end

box.del = function(self, value)
	OpenMe("PROMPT", "Remove this unit ?", f, value)
end